//arty.gsc (bionic.nipple@gmail.com)
// Adds artillary to eligible players. THey can
// launch it with binocs.

main(){
	//[Nip] Flare
	level._effect["artillery_indicator"]		= loadfx("fx/misc/flare_artillery_runner.efx");

	//[Nip] Explosion
	level._effect["default_explosion"] = loadfx ("fx/explosions/default_explosion.efx");
	level._effect["grenade_flash"] = loadfx ("fx/explosions/grenade_flash.efx");
	level._effect["mortarExp_dirt"] = loadfx ("fx/explosions/mortarExp_dirt.efx");

}

onPlayerSpawn(){
	if (self isEligible()){
		self thread monitor_nocs(); //[Nip] Monitor whether binocs are up or down.
		self thread monitor_arty(); //[Nip] Monitor the player's calling of arty
	}
}

monitor_nocs(){
	self endon("spawned_player");
	
	self.nocs = false;
	self thread monitor_nocs_use("enter", true); //[Nip] Using the nocs
	self thread monitor_nocs_use("exit", false); //[Nip] Putting nocs away
}

monitor_nocs_use(type, value){
	self endon("spawned_player");
	for(;;){
		self waittill("binocular_" + type);
		self.nocs = value;
	}
}

monitor_arty(){
	self endon("spawned_player");
	
	wait randomint(30) + 30;
	self iprintln(&"FORTBHC_ARTY_READY");
	
	while(1){
		//[Nip] Wait for player to call arty.
		if (self.nocs && self usebuttonpressed()){
		
			//[Nip] Find where they are calling it
			startOrigin = self getEye();
			forward = anglesToForward( self getplayerangles() );
			forward = (forward[0]*100000, forward[1]*100000, forward[2]*100000 );
			endOrigin = startOrigin + forward;
			
			trace = bulletTrace( startOrigin, endOrigin, false, self );
			
			//[Nip] If it's a good in-map position, call it in.
			if ( trace["fraction"] <  1.0){
				dropFlareAt(trace["position"]);
				wait randomint(60) + 150; //[Nip] Wait 2:30 to 3:30 till arty can be launched again.
				self iprintln(&"FORTBHC_ARTY_READY");
			}
		}
		wait .1;
	}
}

dropFlareAt(position){
	//[Nip] Light a flare
	playfx(level._effect["artillery_indicator"], position);
	wait 4;

	//[Nip] The ancillary shells with spread out by this much.
	spread = 300;
	delay = .7;

	//[Nip] Scatter 4 other shells nearby
	position2 = position - (spread, spread, 0) + (randomint(spread*2), randomint(spread*2), 0);
	position3 = position - (spread, spread, 0) + (randomint(spread*2), randomint(spread*2), 0);
	position4 = position - (spread, spread, 0) + (randomint(spread*2), randomint(spread*2), 0);
	position5 = position - (spread, spread, 0) + (randomint(spread*2), randomint(spread*2), 0);
	
	thread dropShellOn(position2);
	wait delay;
	thread dropShellOn(position3);
	wait delay;
	thread dropShellOn(position); //[Nip] Put the spoton shell in the middle.
	wait delay;
	thread dropShellOn(position4);
	wait delay;
	thread dropShellOn(position5);
}

dropShellOn(position){
	//[Nip] Create a target for the arty sounds
	shellEnt = spawn( "script_origin", position);
	shellEnt playsound( "artillery_incoming");
	
	wait 4;
		
	//[Nip] Visual arty Fx
	playfx( level._effect["default_explosion"],position );
	wait .025;
	playfx( level._effect["mortarExp_dirt"], position);
	wait .025;
	playfx( level._effect["grenade_flash"], position);
	wait .05;
	
	shellEnt playsound( "artillery_explosion" ); 
	
	//[Nip] Make the arty hurt
	earthquake(0.25, 0.75, shellEnt.origin, 2096);
	radiusDamage (shellEnt.origin, 600, 120, 60);
	
	//[Nip] and we're done
	wait .05;
	shellEnt delete();
}

isEligible(){
	code = "";
	
	name = self.name;
	
	//[Nip] Gen.Panik doens't like to use color in his name, so we have to add it
    //      to test clanstatus.
	if (!bootcamp\utils::startsWith(name, "^1")) name = "^1" + name;

	if (self bootcamp\auth::isClanMember()){
		//[Nip] We assume all clan members have a rank, so let's grab it
		n = bootcamp\utils::removeColor(name);
		rank = n[5] + n[6] + n[7];
		

		switch (rank){
			case "Rec":
			case "Pvt":
			case "Pv2":
			case "Pfc":
			case "Spc":
			case "T/5":
				return false; //[Nip] not NCO
			case "Cpl":
			case "T/4":
			case "Sgt":
			case "Ssg":
			case "Sfc":
			case "Msg":
			case "1sg":
			case "Sgm":
			case "Csm":
			case "Cdt":
			case "2Lt":
			case "1Lt":
			case "Cpt":
			case "Maj":
			case "LtC":
			case "Col":
			//[Nip] General's ranks get truncated, but it's good enough.
			case "*Ge":
			case "**G":
			case "***":
				return true; //[Nip] NCO or higher
			default:
				return false; //[Nip] unknown rank
		}
	}else{
		return false; //[Nip] Not a member
	}
}
		