//[Nip] auth.gsc (bionic.nipple@gmail.com)

//[Nip] Set up the tags from cvars or use defaults
main(){
	//[Nip] If tags aren't defined, we'll still use defaults, but
	//      do some trickery in initial spawns.
	level.uses_tags = false;
	
	level.member_tags = parseTags("fortbhc_membertags", "{BHC}");
	level.hq_tags = parseTags("fortbhc_hqtags", "Gen.,Col.,LtC.,Maj.,Cap.,1Lt.,2Lt.,Cdt.,Csm.,Sgm.,1Sg.,Msg.,Sfc.,Ssg.");
	
	level.barracks1_tags = parseTags("fortbhc_1sttags", ".^1");
	level.barracks2_tags = parseTags("fortbhc_2ndtags", ".^4");
	
	level.du_tags = parseTags("fortbhc_dutags", "D.I.,D.S.,D.C.");
	level.recruit_tags = parseTags("fortbhc_recruittags", "Rec.,{Tryout}");
	
	level.arty_tags = parseTags("fortbhc_artytags", "Gen.,Col.,LtC.,Maj.,Cap.,1Lt.,2Lt.,Cdt.,Csm.,Sgm.,1Sg.,Msg.,Sfc.,Ssg.,Sgt.,T/4.,Cpl.");
}

//[Nip] Read tags from cvars (using default if needed) and make a list
parseTags(cvar, def){
	tags = getcvar(cvar);
	if (tags == "" || !isDefined(tags))
		tags = def;
	else level.uses_tags = true;
	tags = strTok(tags, ",");
	return tags;
}


//[Nip] Return whether any of tags are in the name
tagMatch(name, tags){
	//[Nip] "all" matches any name and "none" matches no names
	if (tags.size == 1)
		if (tags[0] == "all")
			return true;
		else if (tags[0] == "none")
			return false;

	//[Nip] Otherwise we have to search for the tag
	for (i=0; i<tags.size; i++)
		if (issubstr(name, tags[i])) return true;
	return false;
}

//[Nip] Determine the players role or clan status
getClanStatus(){
	if (!isPlayer(self) || !isDefined(self.name)) return "none";
	
	name = self.name;
	
	if (!tagMatch(name, level.member_tags)) return "none";
	if (tagMatch(name, level.du_tags)) return "du";
	if (tagMatch(name, level.recruit_tags)) return "recruit";
	return "member";
}
	
isClanMember(){
	if (!isPlayer(self) || !isDefined(self.name)) return false;
	return self getClanStatus() != "none";
}

isRecruit(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return self getClanStatus() == "recruit";
}

isDU(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return self getClanStatus() == "du";
}

spawnsInHQ(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return (tagMatch(self.name, level.hq_tags));
}

spawnsIn1stBarracks(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return (tagMatch(self.name, level.barracks1_tags));
}

spawnsIn2ndBarracks(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return (tagMatch(self.name, level.barracks2_tags));
}

getsArty(){
    if (!isPlayer(self) || !isDefined(self.name)) return false;
    return (tagMatch(self.name, level.arty_tags));
}