//smartspawns.gsc (bionic.nipple@gmail.com)
//This provides a smarter spawn system for bootcamps\training. In addition to
//players first spawning in the appropriate barracks, when they die they will
//respawn at the closest spawn zone to there death point.

onPlayerSpawn(){
	closest = undefined;
		
	//[Nip] If the player hasn't died yet, this must be the first spawn.
	if (!isDefined(self.diedat)){
		closest = getInitialSpawnFor(self);
	}else{
		//[Nip] Determine the closest spawnpoint to where the player died.
		a = self.diedat;
		spawns = getentarray("mp_tdm_spawn", "classname");
		for (i=0; i< spawns.size - 1; i++){
			if (!isDefined(closest))
				closest = spawns[i];
			if (distance(a, spawns[i].origin) < distance(a, closest.origin))
				closest = spawns[i];
		}
	}

	if (isDefined(self.diedat) && isDefined(closest.targetname) && bootcamp\utils::endsWith(closest.targetname, "_spawn")){
		//[Nip] If a player dies and the closest spawn point is an initial spawn point, let's make sure
		//      it's THEIR initial spawn point. This keeps recruits from \kill ing in front of the HQ
		//      building and spawnign in an office.
		closest = getInitialSpawnFor(self);
	}
	
	if (isDefined(closest)){
		//[Nip] Move the player there.
		self setOrigin(closest.origin);
		self setPlayerAngles(closest.angles);
	}
}

onPlayerDeath(){
	self.diedat = self.origin;
}

//[Nip] Figure out where the player's first spawn point should be.
getInitialSpawnFor(player){	
	code = "none";
	name = player.name;

	//[Nip] Find the correct type of spawnpoint for the player
	if (player bootcamp\auth::isClanMember()){
		if (player bootcamp\auth::spawnsInHQ())
			code = "hq";
		else if (player bootcamp\auth::spawnsIn1stBarracks())
			code = "1stplatoon";
		else if (player bootcamp\auth::spawnsIn2ndBarracks())
			code = "2ndplatoon";
		if (player bootcamp\auth::isRecruit())
			code = "recruit";
	}else{
		if (randomint(2))
			code = "1stplatoon";
		else
			code = "2ndplatoon";
	}
	
	//[Nip] Fine the appropriate spawns and pick one.
	spawns = getentarray(code + "_spawn", "targetname");
	if (isDefined(spawns.size) && spawns.size > 0){
		return spawns[randomint(spawns.size)];
	}
	return undefined;
}