//bombs.gsc (bionic.nipple@gmail.com)
//Provides faux SD bomb sites for training.

main(){
	bombs = getentarray("bomb", "targetname");
	if (!isDefined(bombs)) //[Nip] If there aren't any bombs defined, let's dip.
		return;
	
	precacheShader("objectivea");
	precacheShader("objectiveb");
	precacheShader("objectivec");
	precacheShader("objectived");
	precacheShader("objectivee");
	precacheShader("objectivef");
	precacheShader("objective_hq");
	level.bomb_ticking = "objective";
	precacheShader(level.bomb_ticking);

	level.bombmodel = "xmodel/mp_tntbomb";
	level.bombmodelglow = "xmodel/mp_tntbomb_obj";
	precacheModel(level.bombmodel);
	precacheModel(level.bombmodelglow);

	level.bombexplosion = "fx/explosions/flak_puff.efx";
	level.bombsound = "flak88_explode";
	
	level._effect["bombexplosion"] = loadfx(level.bombexplosion);
	
		
	//[Nip] Find all the bombs and set them up
	for (i=0;i<bombs.size;i++){
		bombs[i] thread monitor_bomb(i);
	}
}

monitor_bomb(id){
	switch (id){
	case 0: self.icon = "objectivea"; break;
	case 1: self.icon = "objectiveb"; break;
	case 2: self.icon = "objectivec"; break;
	case 3: self.icon = "objectived"; break;
	case 4: self.icon = "objectivee"; break;
	case 5: self.icon = "objectivef"; break;
	default: self.icon = "objective_hq"; break;
	}

	//[Nip] Shows bomb on compass.
	objective_add(id, "current", self getOrigin(), self.icon);
	
	self.status = "idle"; //[Nip] Status will be "idle", "planting", "ticking", or "defusing"
	
	self.planttime = 5;
	self.defusetime = 5;
	self.fuselength = 60;
	self.barsize = 192;
	
	self.explodefx = level._effect["bombexplosion"];
	self.explodesound = level.bombsound;
		
	while (1){
		//[Nip] We wait for a player to plant or defuse the bomb
		self waittill("trigger", player);
		if (!player isOnGround())
			continue;
			
		//[Nip] Players only plant idle bombs
		if (self.status == "idle"){
			self.status = "planting";
			player clientClaimTrigger(self);
			
			//[Nip] Draw a pretty progress bar on the players screen
			if(!isdefined(player.progressbackground)){
				player.progressbackground = newClientHudElem(player);
				player.progressbackground.x = 0;

				player.progressbackground.y = 104;
				player.progressbackground.alignX = "center";
				player.progressbackground.alignY = "middle";
				player.progressbackground.horzAlign = "center_safearea";
				player.progressbackground.vertAlign = "center_safearea";
				player.progressbackground.alpha = 0.5;
			}
			player.progressbackground setShader("black", (self.barsize + 4), 12);
				
			if(!isdefined(player.progressbar)){
				player.progressbar = newClientHudElem(player);
				player.progressbar.x = int(self.barsize / (-2.0));
				player.progressbar.y = 104;

				player.progressbar.alignX = "left";
				player.progressbar.alignY = "middle";
				player.progressbar.horzAlign = "center_safearea";
				player.progressbar.vertAlign = "center_safearea";
			}
			
			player.progressbar setShader("white", 0, 8);
			player.progressbar scaleOverTime(self.planttime, self.barsize, 8);
			
			//[Nip] THe player sits and plants.
			player playsound("MP_bomb_plant");
			player linkTo(self);
			player disableWeapon();
			
			self.progresstime = 0;
			while(isAlive(player) && player useButtonPressed() && (self.progresstime < self.planttime)){
				self.progresstime += 0.05;
				wait 0.05;
			}
				
			//[Nip] For whatever reason the player has stopped planting.
			player clientreleasetrigger(self);
			player.progressbackground destroy();
			player.progressbar destroy();
			
			
			player unlink();
			player enableWeapon();
			

			//[Nip] If the plant was successsful
			if(self.progresstime >= self.planttime){
				plant = player maps\mp\_utility::getPlant();

				//[Nip] Make a glowing bomb deally.
				self.bombmodel = spawn("script_model", plant.origin);
				self.bombmodel.angles = plant.angles;
				self.bombmodel setmodel(level.bombmodel);
				self.bombmodel playSound("Explo_plant_no_tick");
				self.bombglow = spawn("script_model", plant.origin);
				self.bombglow.angles = plant.angles;
				self.bombglow setmodel(level.bombmodelglow);
				
				self.bombglow playLoopSound("bomb_tick");
				
				//[Nip] Start the countdown to kablooey
				self thread countdown(id);
				
				self.status = "ticking";
				objective_icon(id, level.bomb_ticking);
			} else //[Nip] Otherwise plant was no good. Back to idle.
				self.status = "idle";
		}else if (self.status == "ticking"){
			//[Nip] Players only defuse ticking bombs.
			self.status = "defusing";
			player clientClaimTrigger(self);
			
			//[Nip] Pretty status bar
			if(!isdefined(player.progressbackground)){
				player.progressbackground = newClientHudElem(player);
				player.progressbackground.x = 0;

				player.progressbackground.y = 104;
				player.progressbackground.alignX = "center";
				player.progressbackground.alignY = "middle";
				player.progressbackground.horzAlign = "center_safearea";
				player.progressbackground.vertAlign = "center_safearea";
				player.progressbackground.alpha = 0.5;
			}
			player.progressbackground setShader("black", (self.barsize + 4), 12);
				
			if(!isdefined(player.progressbar)){
				player.progressbar = newClientHudElem(player);
				player.progressbar.x = int(self.barsize / (-2.0));
				player.progressbar.y = 104;

				player.progressbar.alignX = "left";
				player.progressbar.alignY = "middle";
				player.progressbar.horzAlign = "center_safearea";
				player.progressbar.vertAlign = "center_safearea";
			}
			
			player.progressbar setShader("white", 0, 8);
			player.progressbar scaleOverTime(self.defusetime, self.barsize, 8);
			
			//[Nip] Sit and defuse
			player playsound("MP_bomb_defuse");
			player linkTo(self);
			player disableWeapon();
			
			self.progresstime = 0;
			while(isAlive(player) && player useButtonPressed() && (self.progresstime < self.defusetime) && self.status == "defusing"){
				self.progresstime += 0.05;
				wait 0.05;
			}
				
			//[Nip] Successful or not, the defuse is done.
			player clientreleasetrigger(self);
			player.progressbackground destroy();
			player.progressbar destroy();
			
			
			player unlink();
			player enableWeapon();
			
			//[Nip] If it was still ticking while we defused, then the bomb is "dead"
			if(self.progresstime >= self.planttime){
				self notify("defused"); //[Nip] Tells the countdown thread to give up.
				//[Nip] Wait a few seconds and remove the bomb
				self.bombglow delete(); 
				wait 2;
				self.bombmodel delete();
				self.status = "idle";
				objective_icon(id, self.icon);
			} else
				self.status = "ticking";
		}
	}
}

countdown(id){
	//[Nip] Countdown and the do a kablooey
	self endon("defused");
	wait self.fuselength;
	self.bombmodel delete();
	self.bombglow delete();
	self.status = "idle";
	playfx(self.explodefx, self.origin);
	self playSound(self.explodesound);
	earthquake(.5, 5, self.origin, 500);
	objective_icon(id, self.icon);
}
