//[Nip] Drowning Water Script v1
//[Nip]   by BionicNipple (bionic.nipple@gmail.com)
//[Nip]
//[Nip] This script makes a player slowly drown when their head falls below the
//[Nip] water line.
//[Nip]
//[Nip] TO USE: Create a trigger_multiple brush with targetname set to "water"
//[Nip] for each body of water in your map. It should be the same size as the
//[Nip] body of water. Include this file in maps\mp and add the following line
//[Nip] to your mp_mapname.gsc:
//[Nip]
//[Nip] thread maps\mp\drowning::main();


main(){
	precacheShader("white"); //[Nip] Used to tint a drowning player's screen.

	thread onPlayerConnect();
	thread monitor_water();
}


//[Nip] For some reason the mouth needs to be created right away
//[Nip] and not later on when they're in the water.
onPlayerConnect()
{
	for(;;)
	{
		level waittill("connected", player);
		player thread createMouth();
	}
}
	
//[Nip] Create a "mouth". If this ent falls below the water line (i.e. touches) - drown.
createMouth(){
	if (isDefined(self.mouth)) return;
	
	self waittill("spawned");
	wait .5;
	self.mouth = spawn("script_origin", (0, 0, 0));
	self.mouth linkto(self, "j_mouth_le", (0, 0, 0), (0, 0, 0));
}

//[Nip] Search for water pools and monitor them.
monitor_water(){
	pools = getentarray("water", "targetname");
	if (isDefined(pools)){
		for (i=0; i<pools.size; i++){
			if (pools[i].classname == "trigger_multiple"){
				pools[i] thread monitor_pool();
			}
		}
	}
}

//[Nip] Wait till a player jumps in this pool\river\lake.
monitor_pool(){
	while(1){
		self waittill("trigger", player);
		player monitor_player(self);
	}
}

//[Nip] If the mouth is below the water line, slowly drown the player and tint the screen.
monitor_player(trigger){
	if (isDefined(self.isDrowning) && self.isDrowning == true) return;
	
	self.isDrowning = true;
	
	water_vision = newClientHudElem(self);
	water_vision.x = 0;
	water_vision.y = 0;
	water_vision setshader ("white", 640, 480);
	water_vision.alignX = "left";
	water_vision.alignY = "top";
	water_vision.horzAlign = "fullscreen";
	water_vision.vertAlign = "fullscreen";
	water_vision.color = (.16, .38, .5);
	water_vision.alpha = 0;

	while (self.mouth istouching(trigger)){
		self.health -= 10;
		if (self.health < 1){
			self suicide();
			break;
		}
		water_vision.alpha = .75;
		water_vision fadeOverTime(1);
		water_vision.alpha = .25;
		wait 1;
	}
	self.isDrowning = false;
	water_vision destroy();
}
	
	